---
title: CanvasRenderingContext2D.putImageData()
slug: Web/API/CanvasRenderingContext2D/putImageData
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.putImageData()</code></strong> method of the Canvas 2D API paints data from the given {{domxref("ImageData")}} object onto the canvas. If a dirty rectangle is provided, only the pixels from that rectangle are painted. This method is not affected by the canvas transformation matrix.</p>

<div class="note">
<p><strong>Note:</strong> Image data can be retrieved from a canvas using the {{domxref("CanvasRenderingContext2D.getImageData()", "getImageData()")}} method.</p>
</div>

<p>You can find more information about <code>putImageData()</code> and general manipulation of canvas contents in the article <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Pixel_manipulation_with_canvas">Pixel manipulation with canvas</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.putImageData(<em>imageData</em>, <em>dx</em>, <em>dy</em>);
void <em>ctx</em>.putImageData(<em>imageData</em>, <em>dx</em>, <em>dy</em>, <em>dirtyX</em>, <em>dirtyY</em>, <em>dirtyWidth</em>, <em>dirtyHeight</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>imageData</code></dt>
 <dd>An {{domxref("ImageData")}} object containing the array of pixel values.</dd>
 <dt><code>dx</code></dt>
 <dd>Horizontal position (x coordinate) at which to place the image data in the destination canvas.</dd>
 <dt><code>dy</code></dt>
 <dd>Vertical position (y coordinate) at which to place the image data in the destination canvas.</dd>
 <dt><code>dirtyX</code> {{optional_inline}}</dt>
 <dd>Horizontal position (x coordinate) of the top-left corner from which the image data will be extracted. Defaults to <code>0</code>.</dd>
 <dt><code>dirtyY</code> {{optional_inline}}</dt>
 <dd>Vertical position (y coordinate) of the top-left corner from which the image data will be extracted. Defaults to <code>0</code>.</dd>
 <dt><code>dirtyWidth</code> {{optional_inline}}</dt>
 <dd>Width of the rectangle to be painted. Defaults to the width of the image data.</dd>
 <dt><code>dirtyHeight</code> {{optional_inline}}</dt>
 <dd>Height of the rectangle to be painted. Defaults to the height of the image data.</dd>
</dl>

<h3 id="Errors_thrown">Errors thrown</h3>

<dl>
 <dt><code>NotSupportedError</code></dt>
 <dd>Thrown if any of the arguments is infinite.</dd>
 <dt><code>InvalidStateError</code></dt>
 <dd>Thrown if the <code>ImageData</code> object's data has been detached.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Understanding_putImageData">Understanding putImageData</h3>

<p>To understand what this algorithm does under the hood, here is an implementation on top of {{domxref("CanvasRenderingContext2D.fillRect()")}}.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js">var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');

function putImageData(ctx, imageData, dx, dy,
    dirtyX, dirtyY, dirtyWidth, dirtyHeight) {
  var data = imageData.data;
  var height = imageData.height;
  var width = imageData.width;
  dirtyX = dirtyX || 0;
  dirtyY = dirtyY || 0;
  dirtyWidth = dirtyWidth !== undefined? dirtyWidth: width;
  dirtyHeight = dirtyHeight !== undefined? dirtyHeight: height;
  var limitBottom = dirtyY + dirtyHeight;
  var limitRight = dirtyX + dirtyWidth;
  for (var y = dirtyY; y &lt; limitBottom; y++) {
    for (var x = dirtyX; x &lt; limitRight; x++) {
      var pos = y * width + x;
      ctx.fillStyle = 'rgba(' + data[pos*4+0]
                        + ',' + data[pos*4+1]
                        + ',' + data[pos*4+2]
                        + ',' + (data[pos*4+3]/255) + ')';
      ctx.fillRect(x + dx, y + dy, 1, 1);
    }
  }
}

// Draw content onto the canvas
ctx.fillRect(0, 0, 100, 100);
// Create an ImageData object from it
var imagedata = ctx.getImageData(0, 0, 100, 100);
// use the putImageData function that illustrates how putImageData works
putImageData(ctx, imagedata, 150, 0, 50, 50, 25, 25);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Understanding_putImageData', 700, 180) }}</p>

<h3 id="Data_loss_due_to_browser_optimization">Data loss due to browser optimization</h3>

<div class="notecard warning">
<p> Due to the lossy nature of converting to and from premultiplied alpha color values, pixels that have just been set using <code>putImageData()</code> might be returned to an equivalent <code>getImageData()</code> as different values.</p>
</div>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js">const canvas = document.createElement("canvas");
canvas.width = 1;
canvas.height = 1;
const context = canvas.getContext("2d");
const imgData = context.getImageData(0, 0, canvas.width, canvas.height);
const pixels = imgData.data;
pixels[0 + 0] = 1;
pixels[0 + 1] = 127;
pixels[0 + 2] = 255;
pixels[0 + 3] = 1;
console.log("before:", pixels);
context.putImageData(imgData, 0, 0);
const imgData2 = context.getImageData(0, 0, canvas.width, canvas.height);
const pixels2 = imgData2.data;
console.log("after:", pixels2);</pre>

<p>The output might look like:</p>

<pre>before: Uint8ClampedArray(4) [ 1, 127, 255, 1 ]
after: Uint8ClampedArray(4) [ 255, 255, 255, 1 ]</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-putimagedata", "CanvasRenderingContext2D.putImageData")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.putImageData")}}</p>

<h3 id="Gecko-specific_notes">Gecko-specific notes</h3>

<ul>
 <li>Starting in Gecko 10.0 {{ geckoRelease("10.0") }}, non-finite values to any of these parameters cause the call to <code>putImageData()</code> to be silently ignored, rather than throwing an exception.</li>
 <li>To comply with the specification, starting with Gecko 16.0 {{geckoRelease("16.0")}}, a call with an invalid number of arguments (only 3 or 7 arguments are valid), will now throw an error ({{bug(762657)}}).</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("ImageData")}} object</li>
 <li>{{domxref("CanvasRenderingContext2D.getImageData()")}}</li>
 <li><a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Pixel_manipulation_with_canvas">Pixel manipulation with canvas</a></li>
</ul>
